QCPAbstractPlottable Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Functions | Signals | Protected Functions
QCPAbstractPlottable Class Referenceabstract

The abstract base class for all data representing objects in a plot. More...

Inheritance diagram for QCPAbstractPlottable:

## Public Functions
| QCPAbstractPlottable (QCPAxis *keyAxis, QCPAxis *valueAxis)
QString | name () const
bool | antialiasedFill () const
bool | antialiasedScatters () const
QPen | pen () const
QBrush | brush () const
QCPAxis * | keyAxis () const
QCPAxis * | valueAxis () const
QCP::SelectionType | selectable () const
bool | selected () const
QCPDataSelection | selection () const
QCPSelectionDecorator * | selectionDecorator () const
void | setName (const QString &name)
void | setAntialiasedFill (bool enabled)
void | setAntialiasedScatters (bool enabled)
void | setPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setKeyAxis (QCPAxis *axis)
void | setValueAxis (QCPAxis *axis)
Q_SLOT void | setSelectable (QCP::SelectionType selectable)
Q_SLOT void | setSelection (QCPDataSelection selection)
void | setSelectionDecorator (QCPSelectionDecorator *decorator)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const =0
virtual QCPPlottableInterface1D * | interface1D ()
virtual QCPRange | getKeyRange (bool &foundRange, QCP::SignDomain inSignDomain=QCP::sdBoth) const =0
virtual QCPRange | getValueRange (bool &foundRange, QCP::SignDomain inSignDomain=QCP::sdBoth, const QCPRange &inKeyRange=QCPRange()) const =0
void | coordsToPixels (double key, double value, double &x, double &y) const
const QPointF | coordsToPixels (double key, double value) const
void | pixelsToCoords (double x, double y, double &key, double &value) const
void | pixelsToCoords (const QPointF &pixelPos, double &key, double &value) const
void | rescaleAxes (bool onlyEnlarge=false) const
void | rescaleKeyAxis (bool onlyEnlarge=false) const
void | rescaleValueAxis (bool onlyEnlarge=false, bool inKeyRange=false) const
bool | addToLegend (QCPLegend *legend)
bool | addToLegend ()
bool | removeFromLegend (QCPLegend *legend) const
bool | removeFromLegend () const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=nullptr)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Signals
void | selectionChanged (bool selected)
void | selectionChanged (const QCPDataSelection &selection)
void | selectableChanged (QCP::SelectionType selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Protected Functions
virtual QRect | clipRect () const
virtual void | draw (QCPPainter *painter)=0
virtual QCP::Interaction | selectionCategory () const
void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual void | drawLegendIcon (QCPPainter *painter, const QRectF &rect) const =0
void | applyFillAntialiasingHint (QCPPainter *painter) const
void | applyScattersAntialiasingHint (QCPPainter *painter) const
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
virtual void | mousePressEvent (QMouseEvent *event, const QVariant &details)
virtual void | mouseMoveEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseReleaseEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseDoubleClickEvent (QMouseEvent *event, const QVariant &details)
virtual void | wheelEvent (QWheelEvent *event)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Detailed Description

The abstract base class for all data representing objects in a plot.

It defines a very basic interface like name, pen, brush, visibility etc. Since this class is abstract, it can't be instantiated. Use one of the subclasses or create a subclass yourself to create new ways of displaying data (see "Creating own plottables" below). Plottables that display one-dimensional data (i.e. data points have a single key dimension and one or multiple values at each key) are based off of the template subclass QCPAbstractPlottable1D, see details there.

All further specifics are in the subclasses, for example:

- A normal graph with possibly a line and/or scatter points QCPGraph (typically created with QCustomPlot::addGraph)
- A parametric curve: QCPCurve
- A bar chart: QCPBars
- A statistical box plot: QCPStatisticalBox
- A color encoded two-dimensional map: QCPColorMap
- An OHLC/Candlestick chart: QCPFinancial

# Creating own plottables

Subclassing directly from QCPAbstractPlottable is only recommended if you wish to display two-dimensional data like QCPColorMap, i.e. two logical key dimensions and one (or more) data dimensions. If you want to display data with only one logical key dimension, you should rather derive from QCPAbstractPlottable1D.

If subclassing QCPAbstractPlottable directly, these are the pure virtual functions you must implement:

- selectTest
- draw
- drawLegendIcon
- getKeyRange
- getValueRange

See the documentation of those functions for what they need to do.

For drawing your plot, you can use the coordsToPixels functions to translate a point in plot coordinates to pixel coordinates. This function is quite convenient, because it takes the orientation of the key and value axes into account for you (x and y are swapped when the key axis is vertical and the value axis horizontal). If you are worried about performance (i.e. you need to translate many points in a loop like QCPGraph), you can directly use QCPAxis::coordToPixel. However, you must then take care about the orientation of the axis yourself.

Here are some important members you inherit from QCPAbstractPlottable:

QCustomPlot *mParentPlot | A pointer to the parent QCustomPlot instance. The parent plot is inferred from the axes that are passed in the constructor.
QString mName | The name of the plottable.
QPen mPen | The generic pen of the plottable. You should use this pen for the most prominent data representing lines in the plottable (e.g QCPGraph uses this pen for its graph lines and scatters)
QBrush mBrush | The generic brush of the plottable. You should use this brush for the most prominent fillable structures in the plottable (e.g. QCPGraph uses this brush to control filling under the graph)
QPointer<QCPAxis> mKeyAxis, mValueAxis | The key and value axes this plottable is attached to. Call their QCPAxis::coordToPixel functions to translate coordinates to pixels in either the key or value dimension. Make sure to check whether the pointer is `nullptr` before using it. If one of the axes is null, don't draw the plottable.
QCPSelectionDecorator mSelectionDecorator | The currently set selection decorator which specifies how selected data of the plottable shall be drawn and decorated. When drawing your data, you must consult this decorator for the appropriate pen/brush before drawing unselected/selected data segments. Finally, you should call its QCPSelectionDecorator::drawDecoration method at the end of your draw implementation.
QCP::SelectionType mSelectable | In which composition, if at all, this plottable's data may be selected. Enforcing this setting on the data selection is done by QCPAbstractPlottable automatically.
QCPDataSelection mSelection | Holds the current selection state of the plottable's data, i.e. the selected data ranges (QCPDataRange).

## Constructor & Destructor Documentation

## § QCPAbstractPlottable()

QCPAbstractPlottable::QCPAbstractPlottable | ( | QCPAxis * | keyAxis,
|  | QCPAxis * | valueAxis
| ) |  |

Constructs an abstract plottable which uses keyAxis as its key axis ("x") and valueAxis as its value axis ("y"). keyAxis and valueAxis must reside in the same QCustomPlot instance and have perpendicular orientations. If either of these restrictions is violated, a corresponding message is printed to the debug output (qDebug), the construction is not aborted, though.

Since QCPAbstractPlottable is an abstract class that defines the basic interface to plottables, it can't be directly instantiated.

You probably want one of the subclasses like QCPGraph or QCPCurve instead.

## Member Function Documentation

## § selected()

bool QCPAbstractPlottable::selected | ( |  | ) | const
| inline

Returns true if there are any data points of the plottable currently selected. Use selection to retrieve the current QCPDataSelection.

## § selection()

QCPDataSelection QCPAbstractPlottable::selection | ( |  | ) | const
| inline

Returns a QCPDataSelection encompassing all the data points that are currently selected on this plottable.

See also
  selected, setSelection, setSelectable

## § selectionDecorator()

QCPSelectionDecorator * QCPAbstractPlottable::selectionDecorator | ( |  | ) | const
| inline

Provides access to the selection decorator of this plottable. The selection decorator controls how selected data ranges are drawn (e.g. their pen color and fill), see QCPSelectionDecorator for details.

If you wish to use an own QCPSelectionDecorator subclass, pass an instance of it to setSelectionDecorator.

## § setName()

void QCPAbstractPlottable::setName | ( | const QString & | name | ) |

The name is the textual representation of this plottable as it is displayed in the legend (QCPLegend). It may contain any UTF-8 characters, including newlines.

## § setAntialiasedFill()

void QCPAbstractPlottable::setAntialiasedFill | ( | bool | enabled | ) |

Sets whether fills of this plottable are drawn antialiased or not.

Note that this setting may be overridden by QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

## § setAntialiasedScatters()

void QCPAbstractPlottable::setAntialiasedScatters | ( | bool | enabled | ) |

Sets whether the scatter symbols of this plottable are drawn antialiased or not.

Note that this setting may be overridden by QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

## § setPen()

void QCPAbstractPlottable::setPen | ( | const QPen & | pen | ) |

The pen is used to draw basic lines that make up the plottable representation in the plot.

For example, the QCPGraph subclass draws its graph lines with this pen.

See also
  setBrush

## § setBrush()

void QCPAbstractPlottable::setBrush | ( | const QBrush & | brush | ) |

The brush is used to draw basic fills of the plottable representation in the plot. The Fill can be a color, gradient or texture, see the usage of QBrush.

For example, the QCPGraph subclass draws the fill under the graph with this brush, when it's not set to Qt::NoBrush.

See also
  setPen

## § setKeyAxis()

void QCPAbstractPlottable::setKeyAxis | ( | QCPAxis * | axis | ) |

The key axis of a plottable can be set to any axis of a QCustomPlot, as long as it is orthogonal to the plottable's value axis. This function performs no checks to make sure this is the case. The typical mathematical choice is to use the x-axis (QCustomPlot::xAxis) as key axis and the y-axis (QCustomPlot::yAxis) as value axis.

Normally, the key and value axes are set in the constructor of the plottable (or QCustomPlot::addGraph when working with QCPGraphs through the dedicated graph interface).

See also
  setValueAxis

## § setValueAxis()

void QCPAbstractPlottable::setValueAxis | ( | QCPAxis * | axis | ) |

The value axis of a plottable can be set to any axis of a QCustomPlot, as long as it is orthogonal to the plottable's key axis. This function performs no checks to make sure this is the case. The typical mathematical choice is to use the x-axis (QCustomPlot::xAxis) as key axis and the y-axis (QCustomPlot::yAxis) as value axis.

Normally, the key and value axes are set in the constructor of the plottable (or QCustomPlot::addGraph when working with QCPGraphs through the dedicated graph interface).

See also
  setKeyAxis

## § setSelectable()

void QCPAbstractPlottable::setSelectable | ( | QCP::SelectionType | selectable | ) |

Sets whether and to which granularity this plottable can be selected.

A selection can happen by clicking on the QCustomPlot surface (When QCustomPlot::setInteractions contains QCP::iSelectPlottables), by dragging a selection rect (When QCustomPlot::setSelectionRectMode is QCP::srmSelect), or programmatically by calling setSelection.

See also
  setSelection, QCP::SelectionType

## § setSelection()

void QCPAbstractPlottable::setSelection | ( | QCPDataSelection | selection | ) |

Sets which data ranges of this plottable are selected. Selected data ranges are drawn differently (e.g. color) in the plot. This can be controlled via the selection decorator (see selectionDecorator).

The entire selection mechanism for plottables is handled automatically when QCustomPlot::setInteractions contains iSelectPlottables. You only need to call this function when you wish to change the selection state programmatically.

Using setSelectable you can further specify for each plottable whether and to which granularity it is selectable. If selection is not compatible with the current QCP::SelectionType set via setSelectable, the resulting selection will be adjusted accordingly (see QCPDataSelection::enforceType).

emits the selectionChanged signal when selected is different from the previous selection state.

See also
  setSelectable, selectTest

## § setSelectionDecorator()

void QCPAbstractPlottable::setSelectionDecorator | ( | QCPSelectionDecorator * | decorator | ) |

Use this method to set an own QCPSelectionDecorator (subclass) instance. This allows you to customize the visual representation of selected data ranges further than by using the default QCPSelectionDecorator.

The plottable takes ownership of the decorator.

The currently set decorator can be accessed via selectionDecorator.

## § selectTest()

virtual double QCPAbstractPlottable::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `nullptr`
| ) |  | const
| pure virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the object is represented not by single lines but by an area like a QCPItemText or the bars of a QCPBars plottable, a click inside the area should also be considered a hit. In these cases this function thus returns a constant value greater zero but still below the parent plot's selection tolerance. (typically the selectionTolerance multiplied by 0.99).

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

In the case of 1D Plottables (QCPAbstractPlottable1D, like QCPGraph or QCPBars) details will be set to a QCPDataSelection, describing the closest data point to pos.

You may pass `nullptr` as details to indicate that you are not interested in those selection details.

See also
  selectEvent, deselectEvent, mousePressEvent, wheelEvent, QCustomPlot::setInteractions, QCPAbstractPlottable1D::selectTestRect

Reimplemented from QCPLayerable.

Implemented in QCPBars, QCPFinancial, QCPColorMap, QCPErrorBars, QCPGraph, QCPStatisticalBox, QCPCurve, QCPAbstractPlottable1D< DataType >, QCPAbstractPlottable1D< QCPFinancialData >, QCPAbstractPlottable1D< QCPStatisticalBoxData >, QCPAbstractPlottable1D< QCPGraphData >, QCPAbstractPlottable1D< QCPBarsData >, and QCPAbstractPlottable1D< QCPCurveData >.

## § interface1D()

QCPPlottableInterface1D * QCPAbstractPlottable::interface1D | ( |  | ) |
| inlinevirtual

If this plottable is a one-dimensional plottable, i.e. it implements the QCPPlottableInterface1D, returns the this pointer with that type. Otherwise (e.g. in the case of a QCPColorMap) returns zero.

You can use this method to gain read access to data coordinates while holding a pointer to the abstract base class only.

Reimplemented in QCPErrorBars, QCPAbstractPlottable1D< DataType >, QCPAbstractPlottable1D< QCPFinancialData >, QCPAbstractPlottable1D< QCPStatisticalBoxData >, QCPAbstractPlottable1D< QCPGraphData >, QCPAbstractPlottable1D< QCPBarsData >, and QCPAbstractPlottable1D< QCPCurveData >.

## § getKeyRange()

QCPRange QCPAbstractPlottable::getKeyRange | ( | bool & | foundRange,
|  | QCP::SignDomain | inSignDomain = `QCP::sdBoth`
| ) |  | const
| pure virtual

Returns the coordinate range that all data in this plottable span in the key axis dimension. For logarithmic plots, one can set inSignDomain to either QCP::sdNegative or QCP::sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to QCP::sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to QCP::sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero (e.g. when there is only one data point). In this case foundRange would return true, but the returned range is not a valid range in terms of QCPRange::validRange.

See also
  rescaleAxes, getValueRange

Implemented in QCPBars, QCPErrorBars, QCPFinancial, QCPColorMap, QCPGraph, QCPStatisticalBox, and QCPCurve.

## § getValueRange()

QCPRange QCPAbstractPlottable::getValueRange | ( | bool & | foundRange,
|  | QCP::SignDomain | inSignDomain = `QCP::sdBoth`,
|  | const QCPRange & | inKeyRange = `QCPRange()`
| ) |  | const
| pure virtual

Returns the coordinate range that the data points in the specified key range (inKeyRange) span in the value axis dimension. For logarithmic plots, one can set inSignDomain to either QCP::sdNegative or QCP::sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to QCP::sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to QCP::sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

If inKeyRange has both lower and upper bound set to zero (is equal to `QCPRange()`), all data points are considered, without any restriction on the keys.

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero (e.g. when there is only one data point). In this case foundRange would return true, but the returned range is not a valid range in terms of QCPRange::validRange.

See also
  rescaleAxes, getKeyRange

Implemented in QCPBars, QCPErrorBars, QCPFinancial, QCPColorMap, QCPGraph, QCPStatisticalBox, and QCPCurve.

## § coordsToPixels() [1/2]

void QCPAbstractPlottable::coordsToPixels | ( | double | key,
|  | double | value,
|  | double & | x,
|  | double & | y
| ) |  | const

Convenience function for transforming a key/value pair to pixels on the QCustomPlot surface, taking the orientations of the axes associated with this plottable into account (e.g. whether key represents x or y).

key and value are transformed to the coodinates in pixels and are written to x and y.

See also
  pixelsToCoords, QCPAxis::coordToPixel

## § coordsToPixels() [2/2]

const QPointF QCPAbstractPlottable::coordsToPixels | ( | double | key,
|  | double | value
| ) |  | const

This is an overloaded function.

Transforms the given key and value to pixel coordinates and returns them in a QPointF.

## § pixelsToCoords() [1/2]

void QCPAbstractPlottable::pixelsToCoords | ( | double | x,
|  | double | y,
|  | double & | key,
|  | double & | value
| ) |  | const

Convenience function for transforming a x/y pixel pair on the QCustomPlot surface to plot coordinates, taking the orientations of the axes associated with this plottable into account (e.g. whether key represents x or y).

x and y are transformed to the plot coodinates and are written to key and value.

See also
  coordsToPixels, QCPAxis::coordToPixel

## § pixelsToCoords() [2/2]

void QCPAbstractPlottable::pixelsToCoords | ( | const QPointF & | pixelPos,
|  | double & | key,
|  | double & | value
| ) |  | const

This is an overloaded function.

Returns the pixel input pixelPos as plot coordinates key and value.

## § rescaleAxes()

void QCPAbstractPlottable::rescaleAxes | ( | bool | onlyEnlarge = `false` | ) | const

Rescales the key and value axes associated with this plottable to contain all displayed data, so the whole plottable is visible. If the scaling of an axis is logarithmic, rescaleAxes will make sure not to rescale to an illegal range i.e. a range containing different signs and/or zero. Instead it will stay in the current sign domain and ignore all parts of the plottable that lie outside of that domain.

onlyEnlarge makes sure the ranges are only expanded, never reduced. So it's possible to show multiple plottables in their entirety by multiple calls to rescaleAxes where the first call has onlyEnlarge set to false (the default), and all subsequent set to true.

See also
  rescaleKeyAxis, rescaleValueAxis, QCustomPlot::rescaleAxes, QCPAxis::rescale

## § rescaleKeyAxis()

void QCPAbstractPlottable::rescaleKeyAxis | ( | bool | onlyEnlarge = `false` | ) | const

Rescales the key axis of the plottable so the whole plottable is visible.

See rescaleAxes for detailed behaviour.

## § rescaleValueAxis()

void QCPAbstractPlottable::rescaleValueAxis | ( | bool | onlyEnlarge = `false`,
|  | bool | inKeyRange = `false`
| ) |  | const

Rescales the value axis of the plottable so the whole plottable is visible. If inKeyRange is set to true, only the data points which are in the currently visible key axis range are considered.

Returns true if the axis was actually scaled. This might not be the case if this plottable has an invalid range, e.g. because it has no data points.

See rescaleAxes for detailed behaviour.

## § addToLegend() [1/2]

bool QCPAbstractPlottable::addToLegend | ( | QCPLegend * | legend | ) |

This is an overloaded function.

Adds this plottable to the specified legend.

Creates a QCPPlottableLegendItem which is inserted into the legend. Returns true on success, i.e. when the legend exists and a legend item associated with this plottable isn't already in the legend.

If the plottable needs a more specialized representation in the legend, you can create a corresponding subclass of QCPPlottableLegendItem and add it to the legend manually instead of calling this method.

See also
  removeFromLegend, QCPLegend::addItem

## § addToLegend() [2/2]

bool QCPAbstractPlottable::addToLegend | ( |  | ) |

This is an overloaded function.

Adds this plottable to the legend of the parent QCustomPlot (QCustomPlot::legend).

See also
  removeFromLegend

## § removeFromLegend() [1/2]

bool QCPAbstractPlottable::removeFromLegend | ( | QCPLegend * | legend | ) | const

This is an overloaded function.

Removes the plottable from the specifed legend. This means the QCPPlottableLegendItem that is associated with this plottable is removed.

Returns true on success, i.e. if the legend exists and a legend item associated with this plottable was found and removed.

See also
  addToLegend, QCPLegend::removeItem

## § removeFromLegend() [2/2]

bool QCPAbstractPlottable::removeFromLegend | ( |  | ) | const

This is an overloaded function.

Removes the plottable from the legend of the parent QCustomPlot.

See also
  addToLegend

## § selectionChanged [1/2]

void QCPAbstractPlottable::selectionChanged | ( | bool | selected | ) |
| signal

This signal is emitted when the selection state of this plottable has changed, either by user interaction or by a direct call to setSelection. The parameter selected indicates whether there are any points selected or not.

See also
  selectionChanged(const QCPDataSelection &selection)

## § selectionChanged [2/2]

void QCPAbstractPlottable::selectionChanged | ( | const QCPDataSelection & | selection | ) |
| signal

This signal is emitted when the selection state of this plottable has changed, either by user interaction or by a direct call to setSelection. The parameter selection holds the currently selected data ranges.

See also
  selectionChanged(bool selected)

## § selectableChanged

void QCPAbstractPlottable::selectableChanged | ( | QCP::SelectionType | selectable | ) |
| signal

This signal is emitted when the selectability of this plottable has changed.

See also
  setSelectable

## § clipRect()

QRect QCPAbstractPlottable::clipRect | ( |  | ) | const
| protectedvirtual

Returns the clipping rectangle of this layerable object. By default, this is the viewport of the parent QCustomPlot. Specific subclasses may reimplement this function to provide different clipping rects.

The returned clipping rect is set on the painter before the draw function of the respective object is called.

Reimplemented from QCPLayerable.

## § draw()

virtual void QCPAbstractPlottable::draw | ( | QCPPainter * | painter | ) |
| protectedpure virtual

This function draws the layerable with the specified painter. It is only called by QCustomPlot, if the layerable is visible (setVisible).

Before this function is called, the painter's antialiasing state is set via applyDefaultAntialiasingHint, see the documentation there. Further, the clipping rectangle was set to clipRect.

Implements QCPLayerable.

Implemented in QCPBars, QCPColorMap, QCPFinancial, QCPErrorBars, QCPGraph, QCPStatisticalBox, and QCPCurve.

## § selectionCategory()

QCP::Interaction QCPAbstractPlottable::selectionCategory | ( |  | ) | const
| protectedvirtual

Returns the selection category this layerable shall belong to. The selection category is used in conjunction with QCustomPlot::setInteractions to control which objects are selectable and which aren't.

Subclasses that don't fit any of the normal QCP::Interaction values can use QCP::iSelectOther. This is what the default implementation returns.

See also
  QCustomPlot::setInteractions

Reimplemented from QCPLayerable.

## § applyDefaultAntialiasingHint()

void QCPAbstractPlottable::applyDefaultAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protectedvirtual

A convenience function to easily set the QPainter::Antialiased hint on the provided painter before drawing plottable lines.

This is the antialiasing state the painter passed to the draw method is in by default.

This function takes into account the local setting of the antialiasing flag as well as the overrides set with QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

For general information about this virtual method, see the base class implementation.

See also
  setAntialiased, applyFillAntialiasingHint, applyScattersAntialiasingHint

Implements QCPLayerable.

## § selectEvent()

void QCPAbstractPlottable::selectEvent | ( | QMouseEvent * | event,
|  | bool | additive,
|  | const QVariant & | details,
|  | bool * | selectionStateChanged
| ) |  |
| protectedvirtual

This event is called when the layerable shall be selected, as a consequence of a click by the user. Subclasses should react to it by setting their selection state appropriately. The default implementation does nothing.

event is the mouse event that caused the selection. additive indicates, whether the user was holding the multi-select-modifier while performing the selection (see QCustomPlot::setMultiSelectModifier). if additive is true, the selection state must be toggled (i.e. become selected when unselected and unselected when selected).

Every selectEvent is preceded by a call to selectTest, which has returned positively (i.e. returned a value greater than 0 and less than the selection tolerance of the parent QCustomPlot). The details data you output from selectTest is fed back via details here. You may use it to transport any kind of information from the selectTest to the possibly subsequent selectEvent. Usually details is used to transfer which part was clicked, if it is a layerable that has multiple individually selectable parts (like QCPAxis). This way selectEvent doesn't need to do the calculation again to find out which part was actually clicked.

selectionStateChanged is an output parameter. If the pointer is non-null, this function must set the value either to true or false, depending on whether the selection state of this layerable was actually changed. For layerables that only are selectable as a whole and not in parts, this is simple: if additive is true, selectionStateChanged must also be set to true, because the selection toggles. If additive is false, selectionStateChanged is only set to true, if the layerable was previously unselected and now is switched to the selected state.

See also
  selectTest, deselectEvent

Reimplemented from QCPLayerable.

## § deselectEvent()

void QCPAbstractPlottable::deselectEvent | ( | bool * | selectionStateChanged | ) |
| protectedvirtual

This event is called when the layerable shall be deselected, either as consequence of a user interaction or a call to QCustomPlot::deselectAll. Subclasses should react to it by unsetting their selection appropriately.

just as in selectEvent, the output parameter selectionStateChanged (if non-null), must return true or false when the selection state of this layerable has changed or not changed, respectively.

See also
  selectTest, selectEvent

Reimplemented from QCPLayerable.

## § drawLegendIcon()

void QCPAbstractPlottable::drawLegendIcon | ( | QCPPainter * | painter,
|  | const QRectF & | rect
| ) |  | const
| protectedpure virtual

called by QCPLegend::draw (via QCPPlottableLegendItem::draw) to create a graphical representation of this plottable inside rect, next to the plottable name.

The passed painter has its cliprect set to rect, so painting outside of rect won't appear outside the legend icon border.

Implemented in QCPBars, QCPColorMap, QCPFinancial, QCPErrorBars, QCPGraph, QCPStatisticalBox, and QCPCurve.

## § applyFillAntialiasingHint()

void QCPAbstractPlottable::applyFillAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protected

A convenience function to easily set the QPainter::Antialiased hint on the provided painter before drawing plottable fills.

This function takes into account the local setting of the antialiasing flag as well as the overrides set with QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

See also
  setAntialiased, applyDefaultAntialiasingHint, applyScattersAntialiasingHint

## § applyScattersAntialiasingHint()

void QCPAbstractPlottable::applyScattersAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protected

A convenience function to easily set the QPainter::Antialiased hint on the provided painter before drawing plottable scatter points.

This function takes into account the local setting of the antialiasing flag as well as the overrides set with QCustomPlot::setAntialiasedElements and QCustomPlot::setNotAntialiasedElements.

See also
  setAntialiased, applyFillAntialiasingHint, applyDefaultAntialiasingHint

The documentation for this class was generated from the following files:

- src/plottable.h
- src/plottable.cpp